import * as rx from 'rxjs';
export * from './log';
export * from './matcher';
export * from './msg';
export * from './messages';
import { MatcherCallback } from './matcher';
export declare type ObserverCbRet = void | (() => void);
export interface ObserverCb {
    (_: Observer): ObserverCbRet;
}
export declare class MatcherMixin {
    readonly objectId: string;
    readonly obss: Observer[];
    readonly matcher: MatcherCallback[];
    readonly _completed: MatcherCallback[];
    private subscription;
    private unsubscribeCb;
    constructor();
    unsubscribe(): void;
    setUnsubscribeCb(cb: ObserverCbRet): MatcherMixin;
    passTo(sbj: Subject, obs?: Observer | Observer[]): MatcherMixin;
    match(cb: MatcherCallback): void;
    completed(cb: MatcherCallback): void;
}
export declare class Subject extends rx.Subject<RxMe> {
    private readonly mixin;
    constructor();
    completed(cb: MatcherCallback): Subject;
    stopPass(result: boolean): Subject;
    passTo(obs?: Observer | Observer[]): Subject;
    match(cb: MatcherCallback): Subject;
    setUnsubscribeCb(cb: ObserverCbRet): Subject;
    unsubscribe(): Subject;
}
export interface Observer extends rx.Observer<RxMe> {
}
export declare class Observable {
    private readonly observerCb;
    private subject;
    static create(obsCb: ObserverCb): Observable;
    constructor(obsCb: ObserverCb);
    match(cb: MatcherCallback): Observable;
    completed(cb: MatcherCallback): Observable;
    unsubscribe(): Observable;
    passTo(pobs?: Observer | Observer[]): Observable;
}
export declare class RxMe {
    readonly objectId: string;
    readonly data: any;
    constructor(_data: any);
}
export default RxMe;
